package cn.iocoder.yudao.module.delivery.entity;

import cn.iocoder.yudao.framework.common.pojo.PageParam;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.ToString;

import java.math.BigDecimal;
import java.util.List;

/*
 客户分析报表
 逻辑数据大部分集中在表 ecw_customer
 lanbm 2024-03-31 add
 */
@Schema(description = "管理后台 - 客户分析查询参数")
@Data
@ToString(callSuper = true)
public class CustomerAnalysisReq extends PageParam {

    private String orderfield; //排序字段
    private String ordertype; //排序方式


    private int start;
    private int size;

    /*
      客户编号
     */
    //private  String number;

    /*
    客户名称
     */
    private String name;
    private String searchtype;


    /*
    客户国家
     */
    private List<String> country;
    private String countrystr;
    private String countrystrs;

    /*
      客户来源
     */
    private List<Integer> source;
    private String sourcestr;
    private String sourcestrs;

    /*
     销售经理
     */
    private List<String> salesmanid;
    private String salesmanidstr;
    private String salesmanidstrs;

    /*
     部门ID
     */
    private List<String> deptid;
    private String deptidstr;
    private String deptidstrs;

    /*
     客户姓名
     */
    private String cusname;

    /*
    客户编号
     */
    private String cusno;


    /*
     是否首次成交 0是否，1是
     */
    private int first;

    /*
     业绩类型
     */
    private int cusYjType;

    /*
    客户角色
     */
    private List<String> customerrole;
    private String customerrolestr;
    private String customerrolestrs;


    /*
    数据筛选类型
     */
    private String searchDataType1;
    private BigDecimal searchData1;//总V值查询

    private String searchDataType2;
    private BigDecimal searchData2;//海运拼柜

    private String searchDataType3;
    private BigDecimal searchData3; //专线空运

    /*
      客户创建时间
     */
    private String searchDataType4;
    private String sdate4;
    private String edate4;


    /*
    首次成交时间
     */
    private String sdate5;
    private String edate5;


    /*
     时间筛选类型
     首次成交日期，客户创建日期
     */
    private String SearchDateType;
    private String sdate;
    //对比开始日期
    private String sduibidate;

    private String edate;
    //对比结束日期
    private String eduibidate;

    /*
    对比年份
    */
    private String duibiYear;
    private String curYear;//统计年份

    /*
     统计时间跨度 总月数，用户计算月均
     */
    private int nMonth;

}
