package cn.iocoder.yudao.module.delivery.job;

import cn.hutool.core.util.StrUtil;
import cn.iocoder.yudao.framework.common.util.json.JsonUtils;
import cn.iocoder.yudao.framework.quartz.core.handler.JobHandler;
import cn.iocoder.yudao.framework.tenant.core.job.TenantJob;
import cn.iocoder.yudao.module.delivery.service.AllWriteOffService;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

/*
 财务收款单 全部核销定时任务
 lanbm 2024-05-14 add
 myBatis调用存储过程参考
 https://blog.csdn.net/dwenxue/article/details/82257944
 */
@Component
@TenantJob
@Slf4j
public class AllWriteOffJob implements JobHandler {
    //在服务器上配置任务名时，此类的名称要小写，否则无法识别。
    //lanbm 2024-05-19 添加注释
    @Resource
    private AllWriteOffService allWriteOffService;

    @Override
    public String execute(String param) throws Exception {
        int var1 = 24;
        int var2 = 5;
        int var3 = 19;
        if (StringUtils.isNotBlank(param)) {
            String[] vars = param.split(StrUtil.COMMA);
            if (vars.length > 0) {
                var1 = Integer.parseInt(vars[0]);
            }
            if (vars.length > 1) {
                var2 = Integer.parseInt(vars[1]);
            }
            if (vars.length > 2) {
                var3 = Integer.parseInt(vars[2]);
            }
            if(var1==24&&var2==5&&var3==19)
            {
                //String jsonStr = JsonUtils.toJsonString(param);
                //JsonUtils.SaveLog("定时任务参数为："+jsonStr);
                //调用存储过程自动核销
                allWriteOffService.auto_writeoff();
            }
        }
        return "";
    }
}
