package cn.iocoder.yudao.module.delivery.listener;

import cn.iocoder.yudao.framework.apollo.core.event.Customer.CalculateCustomerTypeEvent;
import cn.iocoder.yudao.module.customer.service.customer.CustomerService;
import cn.iocoder.yudao.module.delivery.entity.deptex.zTest;
import cn.iocoder.yudao.module.delivery.service.OrderServiceExt;
import cn.iocoder.yudao.module.delivery.service.ZTestService;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.Date;

/*
 lanbm 2024-05-07 add
 */
@Component("CalculateCustomerType")
@AllArgsConstructor
@Slf4j
public class CalculateCustomerType {
    //监听公海捞取事件，计算客户是新客户类型还是老客户类型，此字段用户计算订单业绩类型
    @Resource
    private CustomerService customerService;

    @Resource
    private ZTestService zTestService;


    @Resource
    private OrderServiceExt orderServiceExt;

    /**
     * 客户捞取监听事件 lanbm 2024-05-07 add
     * @param event
     */
    @EventListener(CalculateCustomerTypeEvent.class)
    public void CalculateCustomerTypePushEvent(
            CalculateCustomerTypeEvent event) {
        zTest m=new zTest();
        String sMsg="计算开始"+event.getCustomerId();
        if (event.getNewCustomerService() == event.getOldCustomerService()) {
            //新客户经理和老客户经理是同一客户经理
            //继续判断有无成交记录
            //有成交记录  客户业绩类型=老客户
            //没成交记录  客户业绩类型=新客户
            sMsg+=",新老一致";
            boolean bR = isHaving_TransactionRecords(event);
            if (bR == true) {
                //有成交记录
                sMsg+=",有成交";
                customerService.updateCustomerNewOrOld(event.getCustomerId(),
                        false);
            } else {
                //无成交记录
                sMsg+=",无成交";
                customerService.updateCustomerNewOrOld(event.getCustomerId(),
                        true);
            }
        } else {
            //新客户经理和老客户经理不是同一客户经理
            //客户业绩类型=新客户
            //不是同一客户经理，不管有无成交记录都要改为新客户 lanbm 2024-05-21 添加业务逻辑备注
            //一客户经理的客户掉入公海池，
            //本人去捞要等48小时，其他客户经理一掉入就可以去捞  lanbm 2024-05-21 添加业务逻辑备注
            sMsg+=",新老不一致";
            customerService.updateCustomerNewOrOld(event.getCustomerId(), true);
        }
        m.setTestname(sMsg);
        m.setCreatedate(new Date());
        zTestService.save(m);
    }

    /*
     通过客户状态来判断有无成交记录
     1.线索2.意向3.成交
     */
    private boolean isHaving_TransactionRecords(CalculateCustomerTypeEvent event) {

        int c=orderServiceExt.IsHavingOrder(event);
        if (c==0)
            return false;
        else
            return true;


    }
}
