package cn.iocoder.yudao.module.delivery.service.Impl;

import cn.iocoder.yudao.framework.common.util.json.JsonUtils;
import cn.iocoder.yudao.module.delivery.entity.*;
import cn.iocoder.yudao.module.delivery.entity.bar.CustomerReportBar;
import cn.iocoder.yudao.module.delivery.entity.bar.SalesReportBar;
import cn.iocoder.yudao.module.delivery.entity.bar.series;
import cn.iocoder.yudao.module.delivery.entity.bar.yAxis;
import cn.iocoder.yudao.module.delivery.mapper.EmployeeMapper;
import cn.iocoder.yudao.module.delivery.mapper.SalesReportMapper;
import cn.iocoder.yudao.module.delivery.service.SalesReportService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.text.NumberFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.time.YearMonth;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

/*
  销售看板统计报表
  lanbm 2024-04-01 add
 */
@Service("SalesReportService")
public class SalesReportImpl implements SalesReportService {

    @Autowired
    private SalesReportMapper salesReportMapper;

    public SalesReportRespAll SalesReportCountAll(SalesReportReq Req) {
        SalesReportRespAll r = null;
        r = salesReportMapper.SalesReportCountAll(Req);
        if (r == null) {
            r = new SalesReportRespAll();
            r.setCurValue(new BigDecimal(0));
            r.setCurValue1(new BigDecimal(0));
            r.setCurValue3(new BigDecimal(0));

            //同比
            r.setTbValue(new BigDecimal(0));
            r.setTbValue1(new BigDecimal(0));
            r.setTbValue3(new BigDecimal(0));

            //环比
            r.setHbValue(new BigDecimal(0));
            r.setHbValue1(new BigDecimal(0));
            r.setHbValue3(new BigDecimal(0));

            r.setTbShow("0");
            r.setHbShow("0");
        } else {
            if (r.getCurValue() == null ||
                    r.getCurValue().compareTo(BigDecimal.ZERO) == 0) {
                r.setCurValue(new BigDecimal(0));
            }

            if (r.getCurValue1() == null ||
                    r.getCurValue1().compareTo(BigDecimal.ZERO) == 0) {
                r.setCurValue1(new BigDecimal(0));
            }

            if (r.getCurValue3() == null ||
                    r.getCurValue3().compareTo(BigDecimal.ZERO) == 0) {
                r.setCurValue3(new BigDecimal(0));
            }

            //同比
            if (r.getTbValue() == null ||
                    r.getTbValue().compareTo(BigDecimal.ZERO) == 0) {
                r.setTbValue(new BigDecimal(0));
            }

            if (r.getTbValue1() == null ||
                    r.getTbValue1().compareTo(BigDecimal.ZERO) == 0) {
                r.setTbValue1(new BigDecimal(0));
            }
            if (r.getTbValue3() == null ||
                    r.getTbValue3().compareTo(BigDecimal.ZERO) == 0) {
                r.setTbValue3(new BigDecimal(0));
            }


            //环比
            if (r.getHbValue() == null ||
                    r.getHbValue().compareTo(BigDecimal.ZERO) == 0) {
                r.setHbValue(new BigDecimal(0));
            }

            if (r.getHbValue1() == null ||
                    r.getHbValue1().compareTo(BigDecimal.ZERO) == 0) {
                r.setHbValue1(new BigDecimal(0));
            }

            if (r.getHbValue3() == null ||
                    r.getHbValue3().compareTo(BigDecimal.ZERO) == 0) {
                r.setHbValue3(new BigDecimal(0));
            }

            //计算同比
            String sTemp = "";
            if (r.getTbValue().compareTo(BigDecimal.ZERO) == 0) {
                sTemp = "同期值为0";
            } else {
                sTemp = getPercentage(r.getCurValue().subtract(r.getTbValue()),
                        r.getTbValue());
            }
            r.setTbShow(sTemp);

            //海运
            if (r.getTbValue1().compareTo(BigDecimal.ZERO) == 0) {
                sTemp = "同期值为0";
            } else {
                sTemp = getPercentage(r.getCurValue1().subtract(r.getTbValue1()),
                        r.getTbValue1());
            }
            r.setTbShow1(sTemp);

            //空运
            if (r.getTbValue3().compareTo(BigDecimal.ZERO) == 0) {
                sTemp = "同期值为0";
            } else {
                sTemp = getPercentage(r.getCurValue3().subtract(r.getTbValue3()),
                        r.getTbValue3());
            }
            r.setTbShow3(sTemp);

            //计算环比
            if (r.getHbValue().compareTo(BigDecimal.ZERO) == 0) {
                sTemp = "上期值为0";
            } else {
                sTemp = getPercentage(r.getCurValue().subtract(r.getHbValue()),
                        r.getHbValue());
            }
            r.setHbShow(sTemp);

            //海运同比
            if (r.getHbValue1().compareTo(BigDecimal.ZERO) == 0) {
                sTemp = "上期期值为0";
            } else {
                sTemp = getPercentage(r.getCurValue1().subtract(r.getHbValue1()),
                        r.getHbValue1());
            }
            r.setHbShow1(sTemp);

            //空运环比
            if (r.getHbValue3().compareTo(BigDecimal.ZERO) == 0) {
                sTemp = "上期期值为0";
            } else {
                sTemp = getPercentage(r.getCurValue3().subtract(r.getHbValue3()),
                        r.getHbValue3());
            }
            r.setHbShow3(sTemp);

        }
        return r;
    }

    public SalesReportResp SalesReportCount(SalesReportReq Req) throws ParseException {
        //String jsonStr = JsonUtils.toJsonString(Req);
        //JsonUtils.SaveLog(jsonStr);

        //当前数据
        SalesReportReq ReqCur = Req;
        //对比数据
        SalesReportReq ReqLast = getReqTb(Req);
        SalesReportResp Resp = salesReportMapper.SalesReportCount(ReqCur);

        if (Resp == null) {
            Resp = new SalesReportResp();
            Resp.setCurValue(new BigDecimal(0));
            Resp.setTbShow("");
            Resp.setHbShow("");
            return Resp;
        }
        //总值
        if (Resp.getCurValue() == null ||
                Resp.getCurValue().compareTo(BigDecimal.ZERO) == 0) {
            Resp.setCurValue(new BigDecimal(0));
        }

        //同比值
        if (Resp.getTbValue() == null ||
                Resp.getTbValue().compareTo(BigDecimal.ZERO) == 0) {
            Resp.setTbValue(new BigDecimal(0));
        }

        //环比值
        if (Resp.getHbValue() == null ||
                Resp.getHbValue().compareTo(BigDecimal.ZERO) == 0) {
            Resp.setHbValue(new BigDecimal(0));
        }

        //计算同比
        String sTemp = "";
        if (Resp.getTbValue().compareTo(BigDecimal.ZERO) == 0) {
            sTemp = "同期值为0";
        } else {
            sTemp = getPercentage(Resp.getCurValue().subtract(Resp.getTbValue()),
                    Resp.getTbValue());
        }
        Resp.setTbShow(sTemp);


        //计算环比
        if (Resp.getHbValue().compareTo(BigDecimal.ZERO) == 0) {
            sTemp = "上期期值为0";
        } else {
            sTemp = getPercentage(Resp.getCurValue().subtract(Resp.getHbValue()),
                    Resp.getHbValue());
        }
        Resp.setHbShow(sTemp);
        return Resp;
    }

    /*
    海运统计
    */
    public SalesReportResp SalesReportCountSea(SalesReportReq Req) throws ParseException {
        SalesReportResp Resp = salesReportMapper.SalesReportCountSea(Req);

        if (Resp == null) {
            Resp = new SalesReportResp();
            Resp.setCurValue(new BigDecimal(0));
            Resp.setTbShow("");
            Resp.setHbShow("");
            return Resp;
        }

        if (Resp.getCurValue() == null ||
                Resp.getCurValue().compareTo(BigDecimal.ZERO) == 0) {
            Resp.setCurValue(new BigDecimal(0));
        }

        //同比值
        if (Resp.getTbValue() == null ||
                Resp.getTbValue().compareTo(BigDecimal.ZERO) == 0) {
            Resp.setTbValue(new BigDecimal(0));
        }

        //环比值
        if (Resp.getHbValue() == null ||
                Resp.getHbValue().compareTo(BigDecimal.ZERO) == 0) {
            Resp.setHbValue(new BigDecimal(0));
        }

        //计算同比
        String sTemp = "";
        if (Resp.getTbValue().compareTo(BigDecimal.ZERO) == 0) {
            sTemp = "同期值为0";
        } else {
            sTemp = getPercentage(Resp.getCurValue().subtract(Resp.getTbValue()),
                    Resp.getTbValue());
        }
        Resp.setTbShow(sTemp);


        //计算环比
        if (Resp.getHbValue().compareTo(BigDecimal.ZERO) == 0) {
            sTemp = "上期期值为0";
        } else {
            sTemp = getPercentage(Resp.getCurValue().subtract(Resp.getHbValue()),
                    Resp.getHbValue());
        }
        Resp.setHbShow(sTemp);
        return Resp;
    }


    /*
     空运统计
     */
    public SalesReportResp SalesReportCountAir(SalesReportReq Req) throws ParseException {
        SalesReportResp Resp = salesReportMapper.SalesReportCountAir(Req);

        if (Resp == null) {
            Resp = new SalesReportResp();
            Resp.setCurValue(new BigDecimal(0));
            Resp.setTbShow("");
            Resp.setHbShow("");
            return Resp;
        }
        //当期值
        if (Resp.getCurValue() == null ||
                Resp.getCurValue().compareTo(BigDecimal.ZERO) == 0) {
            Resp.setCurValue(new BigDecimal(0));
        }

        //同比值
        if (Resp.getTbValue() == null ||
                Resp.getTbValue().compareTo(BigDecimal.ZERO) == 0) {
            Resp.setTbValue(new BigDecimal(0));
        }

        //环比值
        if (Resp.getHbValue() == null ||
                Resp.getHbValue().compareTo(BigDecimal.ZERO) == 0) {
            Resp.setHbValue(new BigDecimal(0));
        }

        //计算同比
        String sTemp = "";
        if (Resp.getTbValue().compareTo(BigDecimal.ZERO) == 0) {
            sTemp = "同期值为0";
        } else {
            sTemp = getPercentage(Resp.getCurValue().subtract(Resp.getTbValue()),
                    Resp.getTbValue());
        }
        Resp.setTbShow(sTemp);


        //计算环比
        if (Resp.getHbValue().compareTo(BigDecimal.ZERO) == 0) {
            sTemp = "上期期值为0";
        } else {
            sTemp = getPercentage(Resp.getCurValue().subtract(Resp.getHbValue()),
                    Resp.getHbValue());
        }

        Resp.setHbShow(sTemp);

        return Resp;
    }

    /*
     获取首次成交统计数据 lanbm 2024-05-09 add
     */
    public SalesReportCusTarget FirstCustomerCount(SalesReportReq Req) throws ParseException {
        Req = getReq(Req);
        //String jsonStr = JsonUtils.toJsonString(Req);
        //JsonUtils.SaveLog(jsonStr);

        //当前数据
        SalesReportReq ReqCur = Req;
        //对比数据
        SalesReportReq ReqLast = getReqTb(Req);

        SalesReportCusTarget objResult = new SalesReportCusTarget();
        int nR = salesReportMapper.FirstCustomerCount(ReqCur);
        int nRTb = salesReportMapper.FirstCustomerCount(ReqLast);
        String sTemp = "";
        if (nRTb == 0) {
            sTemp = "同期值为0";
        } else {
            sTemp = getPercentage(new BigDecimal(nR - nRTb), new BigDecimal(nRTb));
        }
        objResult.setTbShow(sTemp);
        return objResult;
    }

    /*
     根据查询参数获取同比查询参数 lanbm 2024-05-09 add
     */
    private SalesReportReq getReqTb(SalesReportReq Req) {
        SalesReportReq ReqLast = new SalesReportReq();
        ReqLast.setSDate(Req.getSDuiBiDate());
        ReqLast.setEDate(Req.getEDuiBiDate());
        ReqLast.setCurYear(Req.getDuibiYear());
        ReqLast.setDeptid(Req.getDeptid());
        ReqLast.setSalesmanid(Req.getSalesmanid());
        return ReqLast;
    }


    /*
    统计一段时间内客户成交数目，出重客户
    lanbm 2024-05-09 add
    */
    public SalesReportCusTarget CustomerTargetCount(SalesReportReq Req) throws ParseException {
        Req = getReq(Req);
        //String jsonStr = JsonUtils.toJsonString(Req);
        //JsonUtils.SaveLog(jsonStr);

        //当前数据
        SalesReportReq ReqCur = Req;
        //对比数据
        SalesReportReq ReqLast = getReqTb(Req);

        SalesReportCusTarget objResult = new SalesReportCusTarget();
        int nR = salesReportMapper.CustomerTargetCount(Req);
        int nRTb = salesReportMapper.CustomerTargetCount(ReqLast);
        String sTemp = "";
        if (nRTb == 0) {
            sTemp = "同期值为0";
        } else {
            sTemp = getPercentage(new BigDecimal(nR - nRTb), new BigDecimal(nRTb));
        }
        objResult.setTbShow(sTemp);
        return objResult;
    }

    /*
   格式化BigDecimal为字符串，保留两位小数
   lanbm 2024-04-10 add
   */
    private String format(BigDecimal value) {
        NumberFormat numberFormat = NumberFormat.getInstance();
        numberFormat.setMinimumFractionDigits(2);
        numberFormat.setMaximumFractionDigits(2);
        return numberFormat.format(value.doubleValue());
    }

    /*
    计算百分比
    lanbm 2024-04-10 add
    */
    private String getPercentage(BigDecimal part, BigDecimal total) {
        BigDecimal percentage = part.divide(total, 5,
                BigDecimal.ROUND_HALF_UP).multiply(new BigDecimal("100"));
        // 输出百分比
        String sR = format(percentage) + "%";
        return sR;
    }

    private String getCurDate() {
        Date date = new Date();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        String currentDate = sdf.format(date);
        return currentDate;
    }

    private int getCurYear() {
        Calendar calendar = Calendar.getInstance();
        int year = calendar.get(Calendar.YEAR);
        return year;
    }

    /*
     获取某年某月的最后一天 lanbm 2024-04-16 add
     */
    private int getLastDay(int year, int month) {
        YearMonth yearMonth = YearMonth.of(year, month);
        int lastDay = yearMonth.lengthOfMonth();
        return lastDay;
    }

    /*
     对查询日期做初始化处理 lanbm 2024-05-09 add
     */
    public SalesReportReq getReq(SalesReportReq Req) throws ParseException {
        int y = getCurYear();
        if (Req.getDuibiYear() == null) {
            Req.setDuibiYear(String.valueOf(y - 1));
        }

        if (Req.getSDate() == null) {
            Req.setCurYear(String.valueOf(y));
            Req.setSDate(String.valueOf(y) + "-01-01");
            Req.setSDuiBiDate(Req.getDuibiYear() + "-01-01");

        } else {
            //2024-03
            String sT = Req.getSDate();
            Req.setSDate(sT + "-01");

            String s = sT.substring(5, 7);
            Req.setSDuiBiDate(Req.getDuibiYear() + "-" + s + "-01");

            Req.setCurYear(sT.substring(0, 4));
        }

        if (Req.getEDate() == null) {
            Req.setEDate(getCurDate());

            String s = Req.getEDate().substring(5, 7);
            int lastDay = getLastDay(Integer.parseInt(Req.getDuibiYear()), Integer.parseInt(s));
            Req.setEDuiBiDate(Req.getDuibiYear() + "-" + s + "-" + String.valueOf(lastDay));

        } else {
            String sE = Req.getEDate();
            String sY = sE.substring(0, 4);
            String s = sE.substring(5, 7);
            int lastDay = getLastDay(Integer.parseInt(sY), Integer.parseInt(s));
            Req.setEDate(sE + "-" + String.valueOf(lastDay));

            lastDay = getLastDay(Integer.parseInt(Req.getDuibiYear()), Integer.parseInt(s));
            Req.setEDuiBiDate(Req.getDuibiYear() + "-" + s + "-" + String.valueOf(lastDay));
        }
        //计算月份差
        long lc = monthDiff(Req.getSDate(), Req.getEDate());
        if (lc == 0) {
            lc = 1;
        }


        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        Date date1 = format.parse(Req.getSDate());
        Date date2 = format.parse(Req.getEDate());

        //当前日期
        Req.setDS(date1);
        Req.setDE(date2);
        Req.setSumMonth(lc);

        //对比日期
        Date date11 = format.parse(Req.getSDuiBiDate());
        Date date22 = format.parse(Req.getEDuiBiDate());
        Req.setDTbS(date11);
        Req.setDTbE(date22);

        //环比日期

        return Req;
    }

    private int monthDiff(String dateString1, String dateString2) {
        // 将字符串转换为 LocalDate 对象
        LocalDate date1 = LocalDate.parse(dateString1);
        LocalDate date2 = LocalDate.parse(dateString2);

        // 获软时间1的年份和月份
        int year1 = date1.getYear();
        int month1 = date1.getMonthValue();
        // 获取时间2的年份和月份
        int year2 = date2.getYear();
        int month2 = date2.getMonthValue();

        // 计算时间1的总月数
        int totalMonths1 = year1 * 12 + month1;
        // 计算时间2的总月数
        int totalMonths2 = year2 * 12 + month2;
        // 计算总月数差
        int monthsDiff = totalMonths2 - totalMonths1;

        return monthsDiff;
    }

    private List<String> getY_list(SalesReportReq Req) {
        List<String> l = new ArrayList<>();
        //日期格式化
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        Date tmp = Req.getDS();
        Calendar dd = Calendar.getInstance();
        dd.setTime(Req.getDS());
        while (tmp.getTime() < Req.getDE().getTime()) {
            String s = sdf.format(tmp).substring(0, 7);
            l.add(s);
            dd.add(Calendar.MONTH, 1);
            tmp = dd.getTime();
        }
        return l;
    }

    /*
     获取统计数据List
     lanbm 2024-05-15 add
     */
    private List<String> getListTotal(SalesReportReq Req, int n,
                                      SalesReportBar salesReportBar) {
        List<String> s1L = new ArrayList<>();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        Calendar dd = Calendar.getInstance();

        Date tmp = Req.getDS();
        //循环按月份统计数据
        dd.setTime(Req.getDS());

        //计算同比的日历变量
        Calendar dTb = Calendar.getInstance();
        dTb.setTime(Req.getDTbS());
        Date tmpTb = Req.getDTbS();

        //计算环比的日期变量
        Calendar dHb = Calendar.getInstance();

        List<SalesReportResp> resultList = new ArrayList<>();

        while (tmp.getTime() < Req.getDE().getTime()) {
            //月份开始日期
            String s = sdf.format(tmp);
            String sMonthName = s.substring(0, 7);
            Req.setSDate(s);
            String[] parts = s.split("-");
            int lastDay = getLastDay(Integer.parseInt(parts[0]),
                    Integer.parseInt(parts[1]));
            String e = s.substring(0, 7) + "-" + String.valueOf(lastDay);
            Req.setEDate(e);

            String sTb = sdf.format(tmpTb);
            Req.setSDuiBiDate(sTb);
            String[] parts2 = sTb.split("-");
            int lastDayTb = getLastDay(Integer.parseInt(parts2[0]),
                    Integer.parseInt(parts2[1]));
            String eTb = s.substring(0, 7) + "-" + String.valueOf(lastDayTb);
            Req.setEDuiBiDate(eTb);

            Req.setSHuanBiDate(sTb);
            Req.setEHuanBiDate(eTb);

            SalesReportResp r = null;
            if (n == 0) {
                // r = salesReportMapper.SalesReportCount(Req);
            } else if (n == 1)
                r = salesReportMapper.SalesReportCountSea(Req);
            else if (n == 3)
                r = salesReportMapper.SalesReportCountAir(Req);

            //月份名称
            r.setStrMonth(sMonthName);
            resultList.add(r);

            if (r == null) {
                s1L.add("0");
            } else {
                if (r.getCurValue() == null) {
                    s1L.add("0");
                } else {
                    s1L.add(r.getCurValue().toString());
                }
            }
            dd.add(Calendar.MONTH, 1);
            tmp = dd.getTime();

            dTb.add(Calendar.MONTH, 1);
            tmpTb = dTb.getTime();
        }


        return s1L;
    }


    private List<SalesReportRespAll> getReportDataList(SalesReportReq Req) {
        List<String> s1L = new ArrayList<>();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        Calendar dd = Calendar.getInstance();

        Date tmp = Req.getDS();
        //循环按月份统计数据
        dd.setTime(Req.getDS());

        //计算同比的日历变量
        Calendar dTb = Calendar.getInstance();
        dTb.setTime(Req.getDTbS());
        Date tmpTb = Req.getDTbS();

        List<SalesReportRespAll> resultList = new ArrayList<>();

        while (tmp.getTime() < Req.getDE().getTime()) {
            //月份开始日期
            String s = sdf.format(tmp);
            String sMonthName = s.substring(0, 7);
            Req.setSDate(s);
            String[] parts = s.split("-");
            int lastDay = getLastDay(Integer.parseInt(parts[0]),
                    Integer.parseInt(parts[1]));
            String e = s.substring(0, 7) + "-" + String.valueOf(lastDay);
            Req.setEDate(e);

            String sTb = sdf.format(tmpTb);
            Req.setSDuiBiDate(sTb);
            String[] parts2 = sTb.split("-");
            int lastDayTb = getLastDay(Integer.parseInt(parts2[0]),
                    Integer.parseInt(parts2[1]));
            String eTb = s.substring(0, 7) + "-" + String.valueOf(lastDayTb);
            Req.setEDuiBiDate(eTb);

            //根据当前月份计算环比月份
            String sHb=getHbSDate(tmp);
            String eHb=getHbEDate(sHb);
            Req.setSHuanBiDate(sHb);
            Req.setEHuanBiDate(eHb);

            SalesReportRespAll r = null;
            r = SalesReportCountAll(Req);
            //月份名称
            r.setStrMonth(sMonthName);
            resultList.add(r);

            dd.add(Calendar.MONTH, 1);
            tmp = dd.getTime();

            dTb.add(Calendar.MONTH, 1);
            tmpTb = dTb.getTime();
        }
        return resultList;
    }

    /*
     lanbm 2024-05-16 add
     */
    private String getHbSDate(Date dCurDate) {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        //计算环比的日期变量
        Calendar dHb = Calendar.getInstance();
        dHb.setTime(dCurDate);
        dHb.add(Calendar.MONTH, -1);
        Date tmpHb = dHb.getTime();
        String sHb = sdf.format(tmpHb);
        return sHb;
    }

    /*
     lanbm 2024-05-16 add
     */
    private String getHbEDate(String sDate) {
        String[] parts2 = sDate.split("-");
        int lastDayTb = getLastDay(Integer.parseInt(parts2[0]),
                Integer.parseInt(parts2[1]));
        String eHb = sDate.substring(0, 7) + "-" + String.valueOf(lastDayTb);
        return eHb;
    }

    public SalesReportBar getCustomerReportBar(SalesReportReq Req)
            throws ParseException {
        Req = getReq(Req);
        SalesReportBar salesReportBar = new SalesReportBar();

        yAxis y = new yAxis();
        List<String> l = getY_list(Req);
        y.setData(l);
        salesReportBar.setObjyAxis(y);

        List<series> sl = new ArrayList<>();

        List<SalesReportRespAll> resultList = getReportDataList(Req);

        //总V值
        series s1 = new series();

        List<String> s1L = new ArrayList<>();
        for (SalesReportRespAll a : resultList
        ) {
            if (a.getCurValue() == null) {
                a.setCurValue(new BigDecimal(0));
            }
            s1L.add(a.getCurValue().toString());
        }
        s1.setData(s1L);
        sl.add(s1);

        //海运
        series s2 = new series();
        List<String> s2L = new ArrayList<>();
        for (SalesReportRespAll a : resultList
        ) {
            if (a.getCurValue1() == null) {
                a.setCurValue1(new BigDecimal(0));
            }
            s2L.add(a.getCurValue1().toString());
        }
        s2.setData(s2L);
        sl.add(s2);

        //空运
        series s3 = new series();
        List<String> s3L = new ArrayList<>();
        for (SalesReportRespAll a : resultList
        ) {
            if (a.getCurValue3() == null) {
                a.setCurValue3(new BigDecimal(0));
            }
            s3L.add(a.getCurValue3().toString());
        }
        s3.setData(s3L);
        sl.add(s3);

        salesReportBar.setSalesReportRespAll(resultList);
        salesReportBar.setObSseries(sl);
        return salesReportBar;

    }

}
